package org.jeecg;

import cn.com.ctop.common.module.entity.BindAccountLogin;
import cn.com.ctop.common.module.entity.CtopOauthToken;
import cn.com.ctop.common.module.service.IBindAccountLoginService;
import cn.com.ctop.common.module.service.ICtopOauthTokenService;
import cn.com.ctop.common.module.utils.CtopAdConstant;
import cn.com.ctop.crawler.modules.pangolin.service.PangolinAppService;
import cn.com.ctop.crawler.modules.pangolin.service.PangolinCrawlerService;
import cn.com.ctop.crawler.modules.pangolin.service.PangolinLoginService;
import cn.com.ctop.kuaishou.modules.graphql.service.IKuaishouWebInterfaceService;
import cn.com.ctop.toutiao.modules.material.service.IByteDanceAdvertiserDataService;
import cn.com.ctop.toutiao.modules.report.service.IReportService;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import lombok.extern.slf4j.Slf4j;
import org.jeecg.common.util.DateUtils;
import org.jeecg.modules.ctop.entity.KuaishouMatcostAccountMay;
import org.jeecg.modules.ctop.service.IKuaishouMatcostAccountMayService;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

import java.math.BigDecimal;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.concurrent.CountDownLatch;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

@RunWith(SpringRunner.class)
@SpringBootTest
@Slf4j
public class SampleTest {
    @Autowired
    private ICtopOauthTokenService oauthTokenService;
    @Autowired
    private IByteDanceAdvertiserDataService advertiserDataService;
    @Autowired
    private IReportService reportService;
    @Test
    public void testOceanEngineJob() {
        CtopOauthToken token1 = oauthTokenService.getTokenByAccountId(1670725854459911L);
        CtopOauthToken token2 = oauthTokenService.getTokenByAccountId(1670827164313607L);
        CtopOauthToken token3 = oauthTokenService.getTokenByAccountId(1670801593147405L);
        CtopOauthToken token4 = oauthTokenService.getTokenByAccountId(1670827163327501L);
        CtopOauthToken token5 = oauthTokenService.getTokenByAccountId(1670827163853832L);
        for(int i=0;i<100;i++){
            Date startDate = DateUtils.addDay(new Date(),-i);
            reportService.getAdvertiserReport(token1,startDate,startDate,CtopAdConstant.BYTEDANCE_REPORT_TYPE_DAILY);
            reportService.getAdvertiserReport(token2,startDate,startDate,CtopAdConstant.BYTEDANCE_REPORT_TYPE_DAILY);
            reportService.getAdvertiserReport(token3,startDate,startDate,CtopAdConstant.BYTEDANCE_REPORT_TYPE_DAILY);
            reportService.getAdvertiserReport(token4,startDate,startDate,CtopAdConstant.BYTEDANCE_REPORT_TYPE_DAILY);
            reportService.getAdvertiserReport(token5,startDate,startDate,CtopAdConstant.BYTEDANCE_REPORT_TYPE_DAILY);
        }
    }

    @Autowired
    private IBindAccountLoginService bindAccountLoginService;
    @Autowired
    private IKuaishouWebInterfaceService kuaishouWebInterfaceService;

    @Test
    public void kuaishouLogin() {
        Long start = System.currentTimeMillis();
        List<BindAccountLogin> list = bindAccountLoginService.getListByParams(CtopAdConstant.PLATFORM_TYPE_KUAISHOU_PY, 1);
        if (list != null && !list.isEmpty()) {
            for (BindAccountLogin login : list) {
                if (null == login.getCookie() || "".equals(login.getCookie().trim())) {
                    kuaishouWebInterfaceService.getkuaishouWebLoginCookie(login);
                }
            }
        }
        Long end = System.currentTimeMillis();
        log.info("总用时：{}毫秒", end - start);
    }

    static ExecutorService executorService = null;
    static CountDownLatch countDownLatch = null;

    @Test
    public void kuaishouCommentDelete() {
        Long start = System.currentTimeMillis();
        List<BindAccountLogin> list = bindAccountLoginService.getListByParams(CtopAdConstant.PLATFORM_TYPE_KUAISHOU_PY, 1);
        if (list != null && !list.isEmpty()) {
            executorService = Executors.newFixedThreadPool(10);
            countDownLatch = new CountDownLatch(list.size());
            list.forEach(login -> {
                executorService.submit(() -> {
                    try {
                        if (null != login.getCookie() && !"".equals(login.getCookie().trim())) {
                            kuaishouWebInterfaceService.deleteAllComment(new HashMap<>(), login);
                        }
                    } catch (Exception e) {

                    } finally {
                        countDownLatch.countDown();
                    }
                });
            });
        }
        try {
            countDownLatch.await();
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        Long end = System.currentTimeMillis();
        log.info("总用时：{}毫秒", end - start);
    }

    @Autowired
    private PangolinLoginService pangolinLoginService;
    @Autowired
    private PangolinCrawlerService pangolinCrawlerService;
    @Autowired
    private PangolinAppService pangolinAppService;

    @Test
    public void testPangolinLogin() {
        QueryWrapper<BindAccountLogin> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("login_type", "pangolin");
        queryWrapper.eq("status", 1);
        List<BindAccountLogin> list = bindAccountLoginService.list(queryWrapper);
        if (list != null && !list.isEmpty()) {
            for (BindAccountLogin login : list) {
                if (null == login.getCookie() || "".equals(login.getCookie().trim())) {
                    pangolinLoginService.pangolinLogin(login.getAccountName(), login.getPassword());
                }
            }
        }
    }

    @Autowired
    private IKuaishouMatcostAccountMayService matcostAccountMayService;
    @Test
    public void testLoadMinDate(){
        loadData();
    }

    private void loadData(){
        KuaishouMatcostAccountMay matcostAccountMay = matcostAccountMayService.getOne();
        if(null!=matcostAccountMay){
            BigDecimal cost = matcostAccountMayService.getCostByParams(matcostAccountMay);
            if(null!=cost&&!cost.toString().trim().equals("")){
                matcostAccountMayService.updateCostByCode(matcostAccountMay.getVideoCode(),cost);
            }else{
                matcostAccountMayService.updateCostByCode(matcostAccountMay.getVideoCode(),BigDecimal.ZERO);
            }
//            String minDate = matcostAccountMayService.getMinDate(matcostAccountMay.getVideoCode());
//            if(null == minDate||minDate.trim().equals("")){
//                matcostAccountMayService.updateByCode(matcostAccountMay.getVideoCode(),"-");
//            }else{
//                matcostAccountMayService.updateByCode(matcostAccountMay.getVideoCode(),minDate);
//            }

            loadData();
        }
    }

    @Test
    public void testPangolinData() {
        QueryWrapper<BindAccountLogin> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("login_type", "pangolin");
        queryWrapper.eq("status", 1);
        queryWrapper.isNotNull("cookie");
        List<BindAccountLogin> list = bindAccountLoginService.list(queryWrapper);
        if (list != null && !list.isEmpty()) {
            for (BindAccountLogin bindAccountLogin : list) {
                pangolinCrawlerService.getChannelList(bindAccountLogin);
//                pangolinCrawlerService.getActivationList(bindAccountLogin, DateUtils.getNowDate("yyyy-MM-dd"), 1);
//                pangolinCrawlerService.getCheckList(bindAccountLogin);
//                QueryWrapper<PangolinApp> queryWrapper1 = new QueryWrapper<>();
//                queryWrapper1.eq("account_name", bindAccountLogin.getAccountName());
//                List<PangolinApp> appList = pangolinAppService.list(queryWrapper1);
//                if (appList != null && !appList.isEmpty()) {
//                    appList.forEach(pangolinApp -> pangolinCrawlerService.getRealTimeList(bindAccountLogin, pangolinApp.getAppId()));
//                }
            }
        }
    }
}


















