package cn.com.ctop.common.module.service.impl;

import cn.com.ctop.common.module.entity.CorpFeishuUser;
import cn.com.ctop.common.module.mapper.MailLogMapper;
import cn.com.ctop.common.module.service.ICorpFeishuUserService;
import cn.com.ctop.common.module.service.ISendMessageService;
import cn.com.ctop.common.module.utils.Check;
import cn.com.ctop.common.module.utils.CorpWexinUtils;
import cn.com.feishu.provider.MessageProvider;
import com.alibaba.fastjson.JSONArray;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Slf4j
@Service
public class SendMessageServiceImpl implements ISendMessageService {
    @Autowired
    private MailLogMapper mailLogMapper;
    @Autowired
    private ICorpFeishuUserService corpFeishuUserService;
    @Override
    public void sendMessage(String userId, String text) {
        String weChatId = mailLogMapper.getWChatIdByUserId(userId);
        if (!Check.isNull(weChatId)) {
            CorpWexinUtils.sendMessageByWeChatId(weChatId, text);
            log.info("消息发送成功，userId:{}", userId);
        }
    }

    @Override
    public void sendFeishuMessage(String userId, String text) {
        CorpFeishuUser user = corpFeishuUserService.getByUserId(userId);
        if(null!=user){
            JSONArray openIds = new JSONArray();
            openIds.add(user.getOpenId());
            try {
                MessageProvider.batchSend(null,openIds,null,text);
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }

}
